from frostfs_testlib import reporter
from frostfs_testlib.credentials.interfaces import GrpcCredentialsProvider, User
from frostfs_testlib.resources.common import ASSETS_DIR, DEFAULT_WALLET_PASS
from frostfs_testlib.shell.local_shell import LocalShell
from frostfs_testlib.storage.cluster import ClusterNode
from frostfs_testlib.storage.dataclasses.wallet import WalletFactory, WalletInfo


class WalletFactoryProvider(GrpcCredentialsProvider):
    @reporter.step("Init gRPC Credentials using wallet generation")
    def provide(self, user: User, cluster_node: ClusterNode) -> WalletInfo:
        wallet_factory = WalletFactory(ASSETS_DIR, LocalShell())
        user.wallet = wallet_factory.create_wallet(file_name=user.name, password=DEFAULT_WALLET_PASS)
        return user.wallet
